<form [formGroup]="form">
  <!-- Desktop Filter -->
  <div
    class="row d-none d-lg-flex p-4 bottom-border-primary"
    *ngIf="regions$ | async as regions"
  >
    <div class="col-lg-7">
      <div class="row">
        <div class="col-lg">
          <ng-container *ngTemplateOutlet="odSelect"></ng-container>
        </div>
        <div class="col-lg">
          <ng-container *ngTemplateOutlet="doSelect"></ng-container>
        </div>
        <div class="col-lg">
          <ng-container *ngTemplateOutlet="datumSelect"></ng-container>
        </div>
      </div>
    </div>

    <div class="col align-self-center">
      <div class="row">
        <div class="col-lg-auto ml-auto">
          <ng-container *ngTemplateOutlet="voznjeSwitch"></ng-container>
        </div>
        <div class="col-lg-auto">
          <ng-container *ngTemplateOutlet="potraznjeSwitch"></ng-container>
        </div>
      </div>
    </div>
  </div>

  <!-- Mobile Filter -->
  <div class="row d-lg-none">
    <div class="col-12">
      <app-button
        [faIcon]="faSliders"
        [value]="'Filtriraj'"
        classList="mobile-filter-button btn-secondary shadow-lg"
        (clicked)="openMobileFilter(mobileFilter)"
      ></app-button>
    </div>
  </div>
  <!-- Template Outlets -->
  <ng-template #odSelect>
    <ng-select
      *ngIf="regions$ | async as regions"
      [items]="regions"
      class="shadow-sm"
      placeholder="Polazište"
      bindLabel="name"
      bindValue="id"
      formControlName="od"
      (change)="updateQueryParams('od', $event.id)"
      (clear)="updateQueryParams('od', null)"
    ></ng-select>
  </ng-template>

  <ng-template #doSelect>
    <ng-select
      *ngIf="regions$ | async as regions"
      [items]="regions"
      placeholder="Destinacija"
      class="shadow-sm"
      bindLabel="name"
      bindValue="id"
      formControlName="do"
      (change)="updateQueryParams('do', $event.id)"
      (clear)="updateQueryParams('do', null)"
    ></ng-select>
  </ng-template>

  <ng-template #datumSelect>
    <app-date-input
      [minDate]="minDate"
      [maxDate]="maxDate"
      [parentForm]="form"
      [showPrependIcon]="false"
      [classList]="'shadow-sm'"
      [controlName]="'datum'"
      [placeholder]="'Datum'"
      (dateSelected)="updateQueryParams('datum', $event)"
    ></app-date-input>
  </ng-template>

  <ng-template #voznjeSwitch>
    <app-toggle-switch
      (changed)="updateQueryParams('voznje', $event ? 'da' : 'ne')"
      [controlName]="'voznje'"
      [parentForm]="form"
      [label]="'Vožnje'"
    ></app-toggle-switch>
  </ng-template>

  <ng-template #potraznjeSwitch>
    <app-toggle-switch
      (changed)="updateQueryParams('potraznje', $event ? 'da' : 'ne')"
      [controlName]="'potraznje'"
      [label]="'Potražnje'"
      [parentForm]="form"
    ></app-toggle-switch>
  </ng-template>

  <ng-template #mobileFilter let-modal>
    <div class="modal-header">
      <h4 class="modal-title" id="modal-basic-title">Filteri</h4>
      <button
        type="button"
        class="close"
        aria-label="Close"
        (click)="modal.dismiss()"
      >
        <span aria-hidden="true">&times;</span>
      </button>
    </div>
    <div class="modal-body px-0">
      <div class="container-fluid">
        <div class="row">
          <div class="col-12 mb-3">
            <ng-container *ngTemplateOutlet="odSelect"></ng-container>
          </div>
          <div class="col-12 mb-3">
            <ng-container *ngTemplateOutlet="doSelect"></ng-container>
          </div>
          <div class="col-12 mb-3">
            <ng-container *ngTemplateOutlet="datumSelect"></ng-container>
          </div>
          <div class="col-6 pr-0 my-3">
            <ng-container *ngTemplateOutlet="voznjeSwitch"></ng-container>
          </div>
          <div class="col-6 pl-0 my-3">
            <ng-container *ngTemplateOutlet="potraznjeSwitch"></ng-container>
          </div>
        </div>
      </div>
    </div>
    <div class="modal-footer">
      <app-button
        (clicked)="closeModal()"
        value="Zatvori"
        classList="btn-secondary"
      ></app-button>
    </div>
  </ng-template>
</form>
